#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2thirteen4search.py">
#<abstract4xi abstract = "shoots to direction thirteen"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2thirteen4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2thirteen4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2thirteen4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4thirteen

global count2ack4thirteen
global count2nack4thirteen
global count2found4thirteen
global count2short4thirteen

global current2series4thirteen
global candidate2series4thirteen

global fileobject4thirteen  

global keys2profile4thirteen
global key2profile4thirteen

global left2find4thirteen

global maxsize2ack4thirteen    
global maxsize2file4thirteen 
global max2short4thirteen
global meansize2ack4thirteen
global minsize2ack4thirteen

global thirteen2analyse4search

global profile2fetch4thirteen

global right2find4thirteen

global sumsize2ack4thirteen    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4thirteen = VersionKB4Xi['base2shoot4thirteen']             # base internet address, None=local url

count2ack4thirteen   = 0
count2nack4thirteen  = 0
count2found4thirteen = 0
count2short4thirteen = 0

left2find4thirteen = '('

max2short4thirteen = VersionKB4Xi['max2short4thirteen']
maxsize2file4thirteen = VersionKB4Xi['maxsize2file4thirteen']
maxsize2ack4thirteen  = 0
meansize2ack4thirteen = 0
minsize2ack4thirteen  = 0

current2series4thirteen = "current2series4thirteen5dummy"
candidate2series4thirteen  = "candidate2series4thirteen5dummy"


thirteen2analyse4search  = VersionKB4Xi['thirteen2analyse4search']

profile2fetch4thirteen = {}
profile2fetch4thirteen [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4thirteen [2] = '.jpg'
keys2profile4thirteen = profile2fetch4thirteen.keys()

right2find4thirteen = ')'

sumsize2ack4thirteen  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4thirteen" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4thirteen(target2explore4thirteen):
    global count2ack4thirteen
    global count2nack4thirteen
    global count2found4thirteen
    global count2short4thirteen
    
    global fileobject4thirteen 
       
    global keys2profile4thirteen
    global key2profile4thirteen
    
    global left2find4thirteen

    global max2short4thirteen    
    global maxsize2file4thirteen     
    global maxsize2ack4thirteen    
    global meansize2ack4thirteen
    global minsize2ack4thirteen
  
    global candidate2series4thirteen
    global current2series4thirteen
    
    
    global profile2fetch4thirteen                         # extension for files
    
    global right2find4thirteen
    
    global sumsize2ack4thirteen    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4thirteen = count2found4thirteen + 1
    ack2debug4thirteen = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4thirteen)
    
    ack2profile = False
    for key2profile4thirteen in keys2profile4thirteen:
        if name2target[1] == profile2fetch4thirteen[key2profile4thirteen]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2THIRTEEN4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4thirteen
        if ack2debug4thirteen is True:
            print("(STEP 0A/33) OF SHOOT2THIRTEEN4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2THIRTEEN4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4thirteen:
            count2nack4thirteen = count2nack4thirteen + 1
        else:
            count2ack4thirteen = count2ack4thirteen + 1
            sumsize2ack4thirteen = sumsize2ack4thirteen + size2file
            if size2file > maxsize2ack4thirteen:
                maxsize2ack4thirteen = size2file
            if ((size2file < minsize2ack4thirteen) or (minsize2ack4thirteen == 0)):
                print("(STEP 0B/33) OF SHOOT2THIRTEEN4SEARCH - USING MINSIZE2ACK4THIRTEEN: ", minsize2ack4thirteen, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4THIRTEEN:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2thirteen//d\thirteenfly29july2012\thirteenfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4THIRTEEN:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2thirteen//d\thirteenfly29july2012\thirteenfly29july2012 (2).JPG
                minsize2ack4thirteen = size2file
                print("(STEP 0C/33) OF SHOOT2THIRTEEN4SEARCH - SET MINSIZE2ACK4THIRTEEN TO: ", minsize2ack4thirteen, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4THIRTEEN TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2thirteen//d\thirteenfly29july2012\thirteenfly29july2012 (1).JPG
                # SET MINSIZE2ACK4THIRTEEN TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2thirteen//d\thirteenfly29july2012\thirteenfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4thirteen = target2explore4thirteen
            if ack2debug4thirteen is True:print("(STEP 1A/33) OF SHOOT2THIRTEEN4SEARCH - URL2WEB4THIRTEEN: ", url2web4thirteen) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4thirteen,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4thirteen = url2web4thirteen[0:index2edit] + string2use + url2web4thirteen[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4thirteen)
            shortname2web4thirteen = name2web[0]
            if ack2debug4thirteen is True:
                print("(STEP 1B/33) OF SHOOT2THIRTEEN4SEARCH - SHORTNAME2WEB4THIRTEEN: ", shortname2web4thirteen)
                # 
            
            string2find4thirteen = '/'
            ackall2found4thirteen = False           
            while 1:
                if ackall2found4thirteen is True:
                    break
                else:
                    index2find4thirteen=str.find(shortname2web4thirteen,string2find4thirteen)   
                    if index2find4thirteen == -1:
                        ackall2found4thirteen = True
                    else:
                        shortname2web4thirteen = shortname2web4thirteen[index2find4thirteen+1:]
                        
            if ack2debug4thirteen is True:            
                print("(STEP 1C/33) OF SHOOT2THIRTEEN4SEARCH - SHORTNAME2WEB4THIRTEEN: ", shortname2web4thirteen)
                # 
                
            ackall2found4thirteen = False 
            while 1:
                if ackall2found4thirteen is True:
                    break
                else:
                    index2left4thirteen=str.find(shortname2web4thirteen,left2find4thirteen)
                    if index2left4thirteen == -1:
                        current2series4thirteen = shortname2web4thirteen
                        if ack2debug4thirteen is True:
                            print("(STEP 2A/33) OF SHOOT2THIRTEEN4SEARCH - CURRENT2SERIES4THIRTEEN: ", current2series4thirteen) 
                            # 
                        ackall2found4thirteen = True
                         
                    else:
                        index2right4thirteen=str.find(shortname2web4thirteen,right2find4thirteen)
                        if index2right4thirteen == -1:
                            ackall2found4thirteen = True 
                        else:
                            candidate2series4thirteen = shortname2web4thirteen[0:index2left4thirteen]
                            
                            index3find4thirteen=str.find(shortname2web4thirteen,current2series4thirteen)
                            if index3find4thirteen == -1:
                                
                                current2series4thirteen = candidate2series4thirteen
                                if ack2debug4thirteen is True:
                                    print("(STEP 2B/33) OF SHOOT2THIRTEEN4SEARCH - CURRENT2SERIES4THIRTEEN: ", current2series4thirteen) 
                                    # 
                                
                                count2short4thirteen = 0
                                fileobject4thirteen.write('<br />' + '\n')
                            else:
                                shortname2web4thirteen = shortname2web4thirteen[index2left4thirteen:index2right4thirteen+1]
                                if ack2debug4thirteen is True:
                                    print("(STEP 2C/33) OF SHOOT2THIRTEEN4SEARCH - SHORTNAME2WEB4THIRTEEN: ", shortname2web4thirteen)
                                    # 
                                
                                count2short4thirteen = count2short4thirteen + 1
                                if count2short4thirteen >= max2short4thirteen:
                                    count2short4thirteen = 0
                                else:
                                    pass       
                            ackall2found4thirteen = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4thirteen is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4thirteen.write('<br /><b>&raquo;</b><a href="' + url2web4thirteen + '" target="_blank">' + shortname2web4thirteen + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4thirteen = thirteen2analyse4search
                if ack2debug4thirteen is True:
                    print("(STEP 3A/33) OF SHOOT2THIRTEEN4SEARCH - BASE2LOCAL4THIRTEEN: ", base2local4thirteen)
                    #              
                ack2localtries4thirteen = False                   
                while 1:
                    if ack2localtries4thirteen is True:
                        break
                    else:
                        index2find4thirteen=str.find(url2web4thirteen,base2local4thirteen)            
                        # 
                        #  
                        if index2find4thirteen == -1:
                            ack2localtries4thirteen = True
                        else:
                            if ack2debug4thirteen is True:
                                print("(STEP 3B/33) OF SHOOT2THIRTEEN4SEARCH - BASE2BUILD4THIRTEEN: ", base2build4thirteen)
                                # 
                            url2web4thirteen = base2build4thirteen + url2web4thirteen[len(base2local4thirteen):]
                            if ack2debug4thirteen is True:
                                print("(STEP 3C/33) OF SHOOT2THIRTEEN4SEARCH - URL2WEB4THIRTEEN: ", url2web4thirteen)
                                # 
                            
                            if count2short4thirteen < 1: 
                                fileobject4thirteen.write('<br /><b>&raquo;</b><a href="' + url2web4thirteen + '" target="_blank">' + shortname2web4thirteen + '</a>' + '\n')
                            else:
                                fileobject4thirteen.write('<b>&raquo;</b><a href="' + url2web4thirteen + '" target="_blank">' + shortname2web4thirteen + '</a>\n')                            
                            ack2localtries4thirteen = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2THIRTEEN4SEARCH FAILED, FILEOBJECT4THIRTEEN-WRITE-FAILED: ", str(fileobject4thirteen), time4xi())
      
    else:
        
        count2nack4thirteen = count2nack4thirteen + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2thirteen4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2thirteen4search(queue2thirteen = None, consumer_channel2thirteen = None, publisher_channel2thirteen = None, path2thirteen = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4thirteen
    global count2nack4thirteen
    global count2found4thirteen
    
    global fileobject4thirteen    
    
    global maxsize2ack4thirteen    
    global meansize2ack4thirteen
    global minsize2ack4thirteen
    global sumsize2ack4thirteen    
    
    global maxsize2file4thirteen 
    
    global profile2fetch4thirteen                         # extension for files
    global keys2profile4thirteen
    global key2profile4thirteen

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2THIRTEEN4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2THIRTEEN4SEARCH -  QUEUE2THIRTEEN: ", queue2thirteen)      
    # QUEUE2THIRTEEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2THIRTEEN4SEARCH -  CONSUMER_CHANNEL2THIRTEEN: ", consumer_channel2thirteen)
    # CONSUMER_CHANNEL2THIRTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2THIRTEEN4SEARCH -  PUBLISHER_CHANNEL2THIRTEEN: ", publisher_channel2thirteen)          
    # PUBLISHER_CHANNEL2THIRTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2thirteen is None) or (consumer_channel2thirteen is None) or (publisher_channel2thirteen is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2THIRTEEN4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2THIRTEEN4SEARCH - QUEUE2THIRTEEN: ", queue2thirteen)
        print("(STEP 1C/33) OF SHOOT2THIRTEEN4SEARCH - CONSUMER_CHANNEL2THIRTEEN: ", consumer_channel2thirteen) 
        print("(STEP 1D/33) OF SHOOT2THIRTEEN4SEARCH - PUBLISHER_CHANNEL2THIRTEEN: ", publisher_channel2thirteen)
        print("(STEP 1E/33) OF SHOOT2THIRTEEN4SEARCH - PATH2THIRTEEN: ", path2thirteen)     
        
        return
 
    if (not (queue2thirteen is None) and not(consumer_channel2thirteen is None) and not(publisher_channel2thirteen is None) and (path2thirteen is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2THIRTEEN4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2THIRTEEN4SEARCH - QUEUE2THIRTEEN: ", queue2thirteen)
        print("(STEP 2C/33) OF SHOOT2THIRTEEN4SEARCH - CONSUMER_CHANNEL2THIRTEEN: ", consumer_channel2thirteen) 
        print("(STEP 2D/33) OF SHOOT2THIRTEEN4SEARCH - PUBLISHER_CHANNEL2THIRTEEN: ", publisher_channel2thirteen)
        print("(STEP 2E/33) OF SHOOT2THIRTEEN4SEARCH - PATH2THIRTEEN: ", path2thirteen)     
        return           

    if (not (queue2thirteen is None) and not(consumer_channel2thirteen is None) and not(publisher_channel2thirteen is None) and not(path2thirteen is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2THIRTEEN4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2THIRTEEN4SEARCH - QUEUE2THIRTEEN: ", queue2thirteen)
        # QUEUE2THIRTEEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2THIRTEEN4SEARCH - CONSUMER_CHANNEL2THIRTEEN: ", consumer_channel2thirteen)
        # CONSUMER_CHANNEL2THIRTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2THIRTEEN4SEARCH - PUBLISHER_CHANNEL2THIRTEEN: ", publisher_channel2thirteen)
        # PUBLISHER_CHANNEL2THIRTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2THIRTEEN4SEARCH - PATH2THIRTEEN: ", path2thirteen)
        # PATH2THIRTEEN:  F://temp//yophotos//test2thirteen//
       
        print("(STEP 4A/33) OF SHOOT2THIRTEEN4SEARCH - STARTING TO WALK PATH2THIRTEEN: ", path2thirteen)   
        # STARTING TO WALK PATH2THIRTEEN:  F://temp//yophotos//test2thirteen//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4thirteen = None
        try:
            name2index4thirteen = "index2xxxxxxxx4yo.html"
            path2index4thirteen = path2thirteen + name2index4thirteen
            print("(Step 4B/33) OF SHOOT2THIRTEEN4SEARCH - SET PATH2INDEX4THIRTEEN TO: ", path2index4thirteen)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4THIRTEEN: ", path2index4thirteen)          
            #                    
        fileobject4thirteen = None
        try:
            fileobject4thirteen = open(path2index4thirteen,'w')
            print("(Step 4C/33) OF SHOOT2THIRTEEN4SEARCH - OPENED OUTPUT: ", fileobject4thirteen)
            # SHOOT2THIRTEEN4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2thirteen//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4thirteen)         
            # 
        try:                
            fileobject4thirteen.write('<html>\n')
            
            fileobject4thirteen.write('<style type="text/css" media="all">\n')
            fileobject4thirteen.write(' @import "http://www.yourthirteenxi.org/css/halongbay.css";\n')
            fileobject4thirteen.write('</style> \n')
            fileobject4thirteen.write('<p>\n')
            fileobject4thirteen.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4thirteen.write('<br /><a id="000">yourthirteen<b>&Xi;</b> @Content</a>\n')
            fileobject4thirteen.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4thirteen.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4thirteen)         
            #      
        
        
        KB2name4thirteen = {}
        key2name4thirteen = 0
                 
        for file2walk in DirectoryWalker(path2thirteen):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4thirteen [key2name4thirteen] = file2walk
                    print ("KB2NAME4THIRTEEN[", key2name4thirteen, "]: ", KB2name4thirteen [key2name4thirteen])
                    # 
                    
                    key2name4thirteen = key2name4thirteen + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2THIRTEEN4SEARCH - FAILED UPDATING KB2NAME4THIRTEEN WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4thirteen(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4thirteen.write('<br /> \n')
            fileobject4thirteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4thirteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4thirteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4thirteen.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4thirteen.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4thirteen.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4thirteen.write('</p>\n')
            # 
            fileobject4thirteen.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4thirteen)         
            #            
        try:    
            fileobject4thirteen.close()
            print("(Step 4C/33) OF SHOOT2THIRTEEN4SEARCH - CLOSED OUTPUT: ", fileobject4thirteen)         
            # SHOOT2THIRTEEN4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2thirteen//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4thirteen)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2THIRTEEN4SEARCH - STARTING TO ANALYSE KB2NAME4THIRTEEN: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4THIRTEEN:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4thirteen  = {}
        AlphaKB4thirteen['a'] = {}
        AlphaKB4thirteen['b'] = {}
        AlphaKB4thirteen['c'] = {}
        AlphaKB4thirteen['d'] = {}
        AlphaKB4thirteen['e'] = {}
        AlphaKB4thirteen['f'] = {}
        AlphaKB4thirteen['g'] = {}
        AlphaKB4thirteen['h'] = {}
        AlphaKB4thirteen['i'] = {}
        AlphaKB4thirteen['j'] = {}
        AlphaKB4thirteen['k'] = {}
        AlphaKB4thirteen['l'] = {}
        AlphaKB4thirteen['m'] = {}
        AlphaKB4thirteen['n'] = {}
        AlphaKB4thirteen['o'] = {}
        AlphaKB4thirteen['p'] = {}
        AlphaKB4thirteen['q'] = {}
        AlphaKB4thirteen['r'] = {}
        AlphaKB4thirteen['s'] = {}
        AlphaKB4thirteen['t'] = {}
        AlphaKB4thirteen['u'] = {}
        AlphaKB4thirteen['v'] = {}
        AlphaKB4thirteen['w'] = {}
        AlphaKB4thirteen['x'] = {}
        AlphaKB4thirteen['y'] = {}
        AlphaKB4thirteen['z'] = {} 
        keys2AlphaKB4thirteen = AlphaKB4thirteen.keys()
        key2AlphaKB4thirteen  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4thirteen = len(path2thirteen)
        # 
        
        keys2name4thirteen = KB2name4thirteen.keys()
                
        for key2name4thirteen in sorted(keys2name4thirteen):
            # 
            name2optimize4thirteen = KB2name4thirteen[key2name4thirteen]
            # 
            shortcut2level4thirteen = name2optimize4thirteen[len2cut4thirteen:]
            # 
            len2shortcut4thirteen = len(shortcut2level4thirteen)
            if len2shortcut4thirteen == 1:
                try:
                    # LEVEL THIRTEEN CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4thirteen in keys2AlphaKB4thirteen:
                        KB2level1[key2level1] = shortcut2level4thirteen
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2THIRTEEN4SEARCH ** WARNING - SHORTCUT2LEVEL4THIRTEEN: ", shortcut2level4thirteen, " NOT IN KEYS2ALPHAKB4THIRTEEN: ", keys2AlphaKB4thirteen)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED - SHORTCUT2LEVEL4THIRTEEN: ", shortcut2level4thirteen)      
            else:
                try:
                    
                    string2search4thirteen = '\\'
                    shortcut2level4thirteen = shortcut2level4thirteen[2:]
                    
                    index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                    if index2level4thirteen == -1:
                         
                        KB2level2[key2level2] = shortcut2level4thirteen
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                        index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                        if index2level4thirteen == -1:
                            KB2level3[key2level3] = shortcut2level4thirteen
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                            index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                            if index2level4thirteen == -1:
                                KB2level4[key2level4] = shortcut2level4thirteen
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                                index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                                if index2level4thirteen == -1:
                                    KB2level5[key2level5] = shortcut2level4thirteen
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                                    index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                                    if index2level4thirteen == -1:
                                        KB2level6[key2level6] = shortcut2level4thirteen
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                                        index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                                        if index2level4thirteen == -1:
                                            KB2level7[key2level7] = shortcut2level4thirteen
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4thirteen = shortcut2level4thirteen[index2level4thirteen+1:]
                                            index2level4thirteen=str.find(shortcut2level4thirteen,string2search4thirteen)
                                            if index2level4thirteen == -1:
                                                KB2level8[key2level8] = shortcut2level4thirteen
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2THIRTEEN4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4THIRTEEN: ", shortcut2level4thirteen)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED - SHORTCUT2LEVEL4THIRTEEN: ", shortcut2level4thirteen)   
        
        print ("(Step 6A/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # thirteenfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2THIRTEEN4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2THIRTEEN4SEARCH - COUNT2ACK4THIRTEEN; ", count2ack4thirteen)
            # COUNT2ACK4THIRTEEN;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2THIRTEEN4SEARCH - COUNT2NACK4THIRTEEN; ", count2nack4thirteen)
            # COUNT2NACK4THIRTEEN;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2THIRTEEN4SEARCH - COUNT2FOUND4THIRTEEN: ", count2found4thirteen)
            # COUNT2FOUND4THIRTEEN:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2THIRTEEN4SEARCH - FOUND MAX SIZE: ", maxsize2ack4thirteen)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2THIRTEEN4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4thirteen)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4thirteen == 0:
                meansize2ack4thirteen = 0
                print ("(Step 7G1/33) OF SHOOT2THIRTEEN4SEARCH - MEAN SIZE SET: ", meansize2ack4thirteen)
                #  
            else:       
                meansize2ack4thirteen = int(sumsize2ack4thirteen / count2ack4thirteen)
                print ("(Step 7G2/33) OF SHOOT2THIRTEEN4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4thirteen, ", WHERE SUMSIZE2ACK4THIRTEEN: ", sumsize2ack4thirteen, " COUNT2ACK4THIRTEEN: ", count2ack4thirteen)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4THIRTEEN:  10944512  COUNT2ACK4THIRTEEN:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4thirteen < maxsize2file4thirteen:
                print ("(Step 7H/33) OF SHOOT2THIRTEEN4SEARCH - MIN SIZE MET: ", minsize2ack4thirteen)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2THIRTEEN4SEARCH ** MIN DEFINED: ", minsize2ack4thirteen, " EQUALS TO MAXSIZE2FILE4THIRTEEN: ", maxsize2file4thirteen)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2THIRTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2THIRTEEN4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2THIRTEEN4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2THIRTEEN4SEARCH - QUEUE2THIRTEEN: ", queue2thirteen)
        print("(STEP 7Z3/33) OF SHOOT2THIRTEEN4SEARCH - CONSUMER_CHANNEL2THIRTEEN: ", consumer_channel2thirteen) 
        print("(STEP 7Z4/33) OF SHOOT2THIRTEEN4SEARCH - PUBLISHER_CHANNEL2THIRTEEN: ", publisher_channel2thirteen)
        print("(STEP 7Z5/33) OF SHOOT2THIRTEEN4SEARCH - PATH2THIRTEEN: ", path2thirteen)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.thirteenxi.com; www.yourthirteenxi.com; www.yourthirteenxi.org; www.thirteen2xi.com/; www.thirteen4xi.com/; www.thirteen8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2thirteen4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
